<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>helpers.rules &#8212; NLP004  documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=4f649999" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=039e1c02" />
    <script src="../../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for helpers.rules</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">string</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">import</span> <span class="nn">pyparsing</span> <span class="k">as</span> <span class="nn">pp</span>
<span class="kn">import</span> <span class="nn">nltk</span>
<span class="kn">from</span> <span class="nn">nltk</span> <span class="kn">import</span> <span class="n">word_tokenize</span><span class="p">,</span> <span class="n">pos_tag</span><span class="p">,</span> <span class="n">ne_chunk</span>
<span class="kn">import</span> <span class="nn">spacy</span> 
<span class="kn">from</span> <span class="nn">transformers</span> <span class="kn">import</span> <span class="n">pipeline</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>

<span class="n">sys</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="vm">__file__</span><span class="p">)))</span>
<span class="kn">from</span> <span class="nn">helper_functions</span> <span class="kn">import</span> <span class="n">connect_to_db</span>

<div class="viewcode-block" id="get_epochs_number">
<a class="viewcode-back" href="../../helpers/rules.html#helpers.rules.get_epochs_number">[docs]</a>
<span class="k">def</span> <span class="nf">get_epochs_number</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Get epoch information in numeric representation from geological papers (KA, MA, GA).</span>

<span class="sd">    Arguments:</span>
<span class="sd">        text (str): Input string.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>
<span class="sd">        list: List of tuples, each being epoch in format of (&#39;num&#39;, [..., &#39;num&#39;], &#39;epoch_scale (ka, ma, ga, ...)&#39;).</span>
<span class="sd">    &#39;&#39;&#39;</span>

    <span class="n">epoch_indicators_pattern</span> <span class="o">=</span> <span class="s1">&#39;\s+(ka|ma|ga)</span><span class="se">\b</span><span class="s1">&#39;</span>

    <span class="n">epoch_numbers_patterns</span> <span class="o">=</span> <span class="p">[</span>
        <span class="sa">r</span><span class="s1">&#39;\b(\d+)\s+(ka|ma|ga)\b&#39;</span><span class="p">,</span>
        <span class="sa">r</span><span class="s1">&#39;\b(\d+)\s+(\d+)\s+(ka|ma|ga)\b&#39;</span><span class="p">,</span>
        <span class="sa">r</span><span class="s1">&#39;\b(\d+)-(\d+)\s+(ka|ma|ga)\b&#39;</span><span class="p">,</span>
        <span class="sa">r</span><span class="s1">&#39;\b(\d+)–(\d+)\s+(ka|ma|ga)\b&#39;</span><span class="p">,</span>
    <span class="p">]</span>

    <span class="n">results</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="k">for</span> <span class="n">number_pattern</span> <span class="ow">in</span> <span class="n">epoch_numbers_patterns</span><span class="p">:</span>
        <span class="n">pattern</span> <span class="o">=</span> <span class="sa">rf</span><span class="s1">&#39;</span><span class="si">{</span><span class="n">number_pattern</span><span class="si">}{</span><span class="n">epoch_indicators_pattern</span><span class="si">}</span><span class="s1">&#39;</span>
        <span class="n">substrings</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">findall</span><span class="p">(</span><span class="n">number_pattern</span><span class="p">,</span> <span class="n">text</span><span class="p">)</span>
        <span class="n">results</span> <span class="o">+=</span> <span class="n">substrings</span>
    
    <span class="k">return</span> <span class="n">results</span></div>


<div class="viewcode-block" id="get_epoch_name">
<a class="viewcode-back" href="../../helpers/rules.html#helpers.rules.get_epoch_name">[docs]</a>
<span class="k">def</span> <span class="nf">get_epoch_name</span><span class="p">(</span><span class="n">text</span><span class="p">,</span> <span class="n">epoch_numbers</span><span class="o">=</span><span class="p">[]):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Get epoch information in epoch name representation from geological papers.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str): Input string.</span>
<span class="sd">        epoch_numbers (list): List of tuples, representing numerical epochs. Defaults to empty list.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>
<span class="sd">    </span>
<span class="sd">        list: List of strings, each beign epoch name.</span>
<span class="sd">    &#39;&#39;&#39;</span>

    <span class="n">db_connection</span> <span class="o">=</span> <span class="n">connect_to_db</span><span class="p">()</span>
    <span class="n">cursor</span> <span class="o">=</span> <span class="n">db_connection</span><span class="o">.</span><span class="n">cursor</span><span class="p">()</span>
    <span class="n">cursor</span><span class="o">.</span><span class="n">execute</span><span class="p">(</span><span class="s1">&#39;SELECT name, start_ma, end_ma FROM epochs&#39;</span><span class="p">)</span>
    <span class="n">epochs</span> <span class="o">=</span> <span class="n">cursor</span><span class="o">.</span><span class="n">fetchall</span><span class="p">()</span>
    <span class="n">db_connection</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>

    <span class="n">results</span> <span class="o">=</span> <span class="p">[]</span>
    
    <span class="k">for</span> <span class="n">epoch</span> <span class="ow">in</span> <span class="n">epochs</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">epoch</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="ow">in</span> <span class="n">text</span><span class="o">.</span><span class="n">lower</span><span class="p">():</span>
            <span class="n">results</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">epoch</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
                
    <span class="k">for</span> <span class="n">epoch_number</span> <span class="ow">in</span> <span class="n">epoch_numbers</span><span class="p">:</span>
        <span class="n">numbers</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="n">metric</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">epoch_number</span><span class="p">)</span><span class="o">&gt;</span><span class="mi">2</span><span class="p">:</span>
            <span class="n">numbers</span> <span class="o">=</span> <span class="p">[</span><span class="nb">float</span><span class="p">(</span><span class="n">number</span><span class="p">)</span> <span class="k">for</span> <span class="n">number</span> <span class="ow">in</span> <span class="n">epoch_number</span><span class="p">[:</span><span class="mi">2</span><span class="p">]]</span>
            <span class="n">metric</span> <span class="o">=</span> <span class="n">epoch_number</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">numbers</span> <span class="o">=</span> <span class="p">[</span><span class="nb">float</span><span class="p">(</span><span class="n">epoch_number</span><span class="p">[</span><span class="mi">0</span><span class="p">])]</span>
            <span class="n">metric</span> <span class="o">=</span> <span class="n">epoch_number</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span>

        <span class="k">if</span> <span class="n">metric</span> <span class="o">!=</span> <span class="s1">&#39;ma&#39;</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">numbers</span><span class="p">)):</span>
                <span class="k">if</span> <span class="n">metric</span> <span class="o">==</span> <span class="s1">&#39;ka&#39;</span><span class="p">:</span>
                    <span class="n">numbers</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">numbers</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">/</span><span class="mi">1000</span>
                <span class="k">if</span> <span class="n">metric</span> <span class="o">==</span> <span class="s1">&#39;ga&#39;</span><span class="p">:</span>
                    <span class="n">numbers</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">numbers</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">*</span><span class="mi">1000</span>

        <span class="n">filtered_epochs</span> <span class="o">=</span> <span class="p">[</span>
            <span class="n">epoch</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="k">for</span> <span class="n">epoch</span> <span class="ow">in</span> <span class="n">epochs</span>
            <span class="k">if</span> <span class="nb">any</span><span class="p">(</span>
                <span class="nb">float</span><span class="p">(</span><span class="n">epoch</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span> <span class="o">&gt;=</span> <span class="n">number</span> <span class="o">&gt;=</span> <span class="nb">float</span><span class="p">(</span><span class="n">epoch</span><span class="p">[</span><span class="mi">2</span><span class="p">])</span>
                <span class="k">for</span> <span class="n">number</span> <span class="ow">in</span> <span class="n">numbers</span>
            <span class="p">)</span>
        <span class="p">]</span>

        <span class="n">results</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="nb">set</span><span class="p">([</span><span class="o">*</span><span class="n">results</span><span class="p">,</span> <span class="o">*</span><span class="n">filtered_epochs</span><span class="p">]))</span>

    <span class="k">return</span> <span class="n">results</span></div>



<div class="viewcode-block" id="get_key_words">
<a class="viewcode-back" href="../../helpers/rules.html#helpers.rules.get_key_words">[docs]</a>
<span class="k">def</span> <span class="nf">get_key_words</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Get key words like, volcano, isotop, etc. as a dictionary in form of key_word: True/False.</span>

<span class="sd">    Arguments:</span>
<span class="sd">        text (str): Input string.</span>

<span class="sd">    Returns:</span>
<span class="sd">        dictionary: Dictionary indicating if the key_word is in the text or not, in form of True/False.</span>
<span class="sd">    &#39;&#39;&#39;</span>

    <span class="n">key_words</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s1">&#39;volcan&#39;</span><span class="p">:</span> <span class="kc">False</span><span class="p">,</span>
        <span class="s1">&#39;isotop&#39;</span><span class="p">:</span> <span class="kc">False</span><span class="p">,</span>
    <span class="p">}</span>

    <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">_</span> <span class="ow">in</span> <span class="n">key_words</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
        <span class="n">key_words</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">text</span>
    
    <span class="k">return</span> <span class="n">key_words</span></div>



<div class="viewcode-block" id="dcg">
<a class="viewcode-back" href="../../helpers/rules.html#helpers.rules.dcg">[docs]</a>
<span class="k">def</span> <span class="nf">dcg</span><span class="p">(</span><span class="n">text</span><span class="p">,</span> <span class="n">grammar</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Uses ntlk.CFG to perform Definite Clause Grammar analisis on text.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str): Input text.</span>
<span class="sd">        grammar (str): String prolog like grammar definition.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>

<span class="sd">        nltk.tree.tree.Tree: An nltk tree with tokens at leaves.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="c1"># grammar = &quot;&quot;&quot;</span>
    <span class="c1">#         S -&gt; NP VP</span>
    <span class="c1">#         NP -&gt; Det N | N</span>
    <span class="c1">#         VP -&gt; V | V PP | M V | M V PP</span>
    <span class="c1">#         Det -&gt; &#39;the&#39; | &#39;a&#39; | &#39;this&#39; | &#39;that&#39; | &#39;those&#39; | &#39;these&#39;</span>
    <span class="c1">#         N -&gt; &#39;rock&#39; | &#39;volcano&#39; | &#39;sample&#39; | &#39;plateau&#39; | &#39;rocks&#39; </span>
    <span class="c1">#         V -&gt; &#39;found&#39; | &#39;collected&#39;</span>
    <span class="c1">#         M -&gt; &#39;was&#39; | &#39;has been&#39; | &#39;has&#39; | &#39;were&#39; | &#39;have&#39; | &#39;have been&#39;</span>
    <span class="c1">#         PP -&gt; P NP</span>
    <span class="c1">#         P -&gt; &#39;in&#39; | &#39;near&#39;</span>
    <span class="c1">#     &quot;&quot;&quot;</span>

    <span class="n">grammar</span> <span class="o">=</span> <span class="n">nltk</span><span class="o">.</span><span class="n">CFG</span><span class="o">.</span><span class="n">fromstring</span><span class="p">(</span><span class="n">grammar</span><span class="p">)</span>

    <span class="n">parser</span> <span class="o">=</span> <span class="n">nltk</span><span class="o">.</span><span class="n">RecursiveDescentParser</span><span class="p">(</span><span class="n">grammar</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">allParses</span><span class="p">(</span><span class="n">sentence</span><span class="p">):</span>
        <span class="c1"># sentence = sentence.split()</span>
        <span class="n">tokens</span> <span class="o">=</span> <span class="n">nltk</span><span class="o">.</span><span class="n">word_tokenize</span><span class="p">(</span><span class="n">sentence</span><span class="p">)</span>
        <span class="n">processed_tokens</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">token</span> <span class="ow">in</span> <span class="n">tokens</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">token</span><span class="o">.</span><span class="n">isdigit</span><span class="p">()</span> <span class="ow">and</span> <span class="nb">len</span><span class="p">(</span><span class="n">token</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span><span class="p">:</span>
                <span class="n">processed_tokens</span><span class="o">.</span><span class="n">extend</span><span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="n">token</span><span class="p">))</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">processed_tokens</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">token</span><span class="p">)</span>

        <span class="k">try</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">parser</span><span class="o">.</span><span class="n">parse</span><span class="p">(</span><span class="n">processed_tokens</span><span class="p">)</span>
        <span class="k">except</span> <span class="ne">ValueError</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">None</span>
    
    <span class="n">result</span> <span class="o">=</span> <span class="n">allParses</span><span class="p">(</span><span class="n">text</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">result</span></div>


<div class="viewcode-block" id="named_entity_spacy">
<a class="viewcode-back" href="../../helpers/rules.html#helpers.rules.named_entity_spacy">[docs]</a>
<span class="k">def</span> <span class="nf">named_entity_spacy</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Uses spaxy en_core_web_sm to identify entities.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str): Input text.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>

<span class="sd">        list: A list, where each item a list, containing the token (part of the text), the token&#39;s entity annotation and the token&#39;s entity type.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">nlp</span> <span class="o">=</span> <span class="n">spacy</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="s2">&quot;en_core_web_sm&quot;</span><span class="p">)</span>
    <span class="n">input_text</span> <span class="o">=</span> <span class="n">nlp</span><span class="p">(</span><span class="n">text</span><span class="p">)</span>

    <span class="n">result</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="k">for</span> <span class="n">token</span> <span class="ow">in</span> <span class="n">input_text</span><span class="p">:</span>
        <span class="n">result</span><span class="o">.</span><span class="n">append</span><span class="p">([</span><span class="n">token</span><span class="o">.</span><span class="n">text</span><span class="p">,</span> <span class="n">token</span><span class="o">.</span><span class="n">ent_iob_</span><span class="p">,</span> <span class="n">token</span><span class="o">.</span><span class="n">ent_type_</span><span class="p">])</span>

    <span class="k">return</span> <span class="n">result</span></div>


<div class="viewcode-block" id="named_entity_nltk">
<a class="viewcode-back" href="../../helpers/rules.html#helpers.rules.named_entity_nltk">[docs]</a>
<span class="k">def</span> <span class="nf">named_entity_nltk</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Uses nltk ne_chunk to identify entities.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str): Input text.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>

<span class="sd">        nltk.tree.tree.Tree: An nltk tree with tokens at leaves.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">tokenized_text</span> <span class="o">=</span> <span class="n">word_tokenize</span><span class="p">(</span><span class="n">text</span><span class="p">)</span>
    <span class="n">tagged_text</span> <span class="o">=</span> <span class="n">pos_tag</span><span class="p">(</span><span class="n">tokenized_text</span><span class="p">)</span>
    <span class="n">result</span> <span class="o">=</span> <span class="n">ne_chunk</span><span class="p">(</span><span class="n">tagged_text</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">result</span></div>


<div class="viewcode-block" id="named_entity_bert">
<a class="viewcode-back" href="../../helpers/rules.html#helpers.rules.named_entity_bert">[docs]</a>
<span class="k">def</span> <span class="nf">named_entity_bert</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Uses fine-tuned bert (balamurugan1603/bert-finetuned-ner) to search got named entities.</span>

<span class="sd">    Arguments:</span>

<span class="sd">        text (str): Input text.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>

<span class="sd">        list: List where each elent is a dictionary, containing entity_group, score, word/entity, start and end of entity in the text.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">model_checkpoint</span> <span class="o">=</span> <span class="s2">&quot;balamurugan1603/bert-finetuned-ner&quot;</span>
    <span class="n">namedEntityRecogniser</span> <span class="o">=</span> <span class="n">pipeline</span><span class="p">(</span>
        <span class="s2">&quot;token-classification&quot;</span><span class="p">,</span>
        <span class="n">model</span><span class="o">=</span><span class="n">model_checkpoint</span><span class="p">,</span>
        <span class="n">aggregation_strategy</span><span class="o">=</span><span class="s2">&quot;simple&quot;</span>
    <span class="p">)</span>

    <span class="k">return</span> <span class="n">namedEntityRecogniser</span><span class="p">(</span><span class="n">text</span><span class="p">)</span></div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">NLP004</a></h1>








<h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../modules.html">python</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../pipe.html">pipe</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Ughur Mammadzada.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>